package com.javaonpdas;

import java.util.*;

public class SnapShot {
  private long lastFreeMemory = -1;
  private long lastTime = -1;
  Runtime runtime = null;

  public SnapShot() {
    runtime = Runtime.getRuntime();
  }

  public void snap() {
    runtime.gc();
    long currentFreeMemory = runtime.freeMemory();
    long currentTime = new Date().getTime();
    if ((lastFreeMemory != -1) && (lastTime != -1)) {
      System.out.println("memory used (bytes): " +
        (lastFreeMemory-currentFreeMemory));
      System.out.println("time taken (ms): " +
        (currentTime-lastTime));
    }
    else {
      System.out.println("memory available (bytes): " +
        currentFreeMemory);
    }
    lastFreeMemory = currentFreeMemory;
    lastTime = currentTime;
  }
}
