package com.javaonpdas.introduction;

import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class SimplestMIDlet extends MIDlet
  implements CommandListener {

  protected Form mainForm = new Form("SimplestMIDlet");
  protected Command exitCommand =
    new Command("Exit", Command.EXIT, 1);
  protected Command pauseCommand =
    new Command("Pause", Command.SCREEN, 1);
  protected Display display = null;

  // In the constructor we add commands to the form, and tell
  // the form that this class will handle command events.
  public SimplestMIDlet() {
    mainForm.addCommand(exitCommand);
    mainForm.addCommand(pauseCommand);
    mainForm.setCommandListener(this);
  }

  // The startApp method is called when the MIDlet is created.
  public void startApp() {
    display = Display.getDisplay(this);
    display.setCurrent(mainForm);
    System.out.println("entered active state");
  }

  // The pauseApp method is called when the MIDlet enters the
  // paused state.
  public void pauseApp() {
    System.out.println("entered paused state");
  }

  // The destroyApp method is called when the MIDlet should save
  // its state and free any resources
  public void destroyApp(boolean unconditional) {
    System.out.println(
      "entered destroyed state (unconditional:" +
      unconditional + ")");
  }

  // The commandAction method is called when a command event
  // occurs
  public void commandAction(Command c, Displayable d) {
    if (c == exitCommand) {
      destroyApp(false);
      notifyDestroyed();
    }
    else if (c == pauseCommand) {
      // The developer can cause the MIDlet to enter paused
      // state by calling the notifyPaused method
      notifyPaused();
    }
  }
}
