package com.javaonpdas.small;

import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import java.util.*;

public class MemoryMIDlet extends MIDlet
  implements CommandListener {

  protected Form mainForm = new Form("MemoryMIDlet");
  protected Command exitCommand =
    new Command("Exit", Command.EXIT, 10);
  protected Command allocateCommand =
    new Command("Allocate", Command.SCREEN, 1);
  protected Display display = null;
  private byte[] largeArray = null;
  private long beforeFree;
  private long afterFree;

  public MemoryMIDlet() {
    mainForm.addCommand(exitCommand);
    mainForm.addCommand(allocateCommand);
    mainForm.setCommandListener(this);
  }

  public void startApp() {
    display = Display.getDisplay(this);
    display.setCurrent(mainForm);
  }

  public void pauseApp() {
  }

  public void destroyApp(boolean unconditional) {
  }

  public void commandAction(Command c, Displayable d) {
    if (c == allocateCommand) {
      Runtime runtime = Runtime.getRuntime();
      runtime.gc();
      beforeFree = runtime.freeMemory();
      largeArray = new byte[1000];
      runtime.gc();
      afterFree = runtime.freeMemory();
      System.out.println("Total: " + runtime.totalMemory() +
        " Free (before): " + beforeFree +
        " Free (after): " + afterFree);
    }
    else if (c == exitCommand) {
      destroyApp(false);
      notifyDestroyed();
    }
  }
}
