package com.javaonpdas.ui;

import javax.microedition.lcdui.*;

public class ChoiceTickerMIDlet extends BaseUIMIDlet {

  protected static final String[] MEDIA = {"DVD", "VHS"};
  protected Command choiceCommand =
    new Command("Choice", Command.SCREEN, 1);
  protected Ticker ticker =
    new Ticker("Special: Choose 2 movies for $6...");

  public ChoiceTickerMIDlet() {
    super();
    mainForm.setTitle("ChoiceTickerMIDlet");
    mainForm.addCommand(choiceCommand);
    mainForm.setTicker(ticker);
  }

  public void commandAction(Command c, Displayable d) {
    if (c == choiceCommand) {
      Form choiceForm = new Form("Movie Selection");
      ChoiceGroup singleChoice = new ChoiceGroup("Media",
        ChoiceGroup.EXCLUSIVE, MEDIA, null);
      ChoiceGroup multipleChoice = new ChoiceGroup("Movies",
        ChoiceGroup.MULTIPLE, MOVIES, null);
      choiceForm.append(singleChoice);
      choiceForm.append(multipleChoice);
      choiceForm.addCommand(okCommand);
      choiceForm.addCommand(backCommand);
      choiceForm.addCommand(exitCommand);
      choiceForm.setTicker(ticker);
      choiceForm.setCommandListener(this);
      display.setCurrent(choiceForm);
    }
    else if (c == okCommand) {
      Form choiceForm = (Form)d;
      ChoiceGroup singleChoice =
        (ChoiceGroup)(choiceForm.get(0));
      ChoiceGroup multipleChoice =
        (ChoiceGroup)(choiceForm.get(1));
      // get the media selection
      int i = singleChoice.getSelectedIndex();
      String mediaSelected = singleChoice.getString(i);
      // get the movie selection
      String movieSelected = new String();
      boolean[] selections = new boolean[multipleChoice.size()];
      multipleChoice.getSelectedFlags(selections);
      for (int j=0; j<selections.length; j++)
        if (selections[j])
          movieSelected += multipleChoice.getString(j) +
            " on " + mediaSelected + "\n";
      // display the result
      Alert alert = new Alert("Selection");
      alert.setString(movieSelected);
      alert.setTimeout(5000);
      alert.setType(AlertType.INFO);
      alert.setTicker(ticker);
      display.setCurrent(alert, mainForm);
    }
    else if (c == backCommand) {
      display.setCurrent(mainForm);
    }
    else {
      super.commandAction(c, d);
    }
  }
}
