package com.javaonpdas.ui;

import javax.microedition.lcdui.*;

public class TextFieldMIDlet extends BaseUIMIDlet {

  private Command textFieldCommand =
    new Command("TextField", Command.SCREEN, 1);

  public TextFieldMIDlet() {
    super();
    mainForm.setTitle("TextFieldMIDlet");
    mainForm.addCommand(textFieldCommand);
  }

  public void commandAction(Command c, Displayable d) {
    if (c == textFieldCommand) {
      Form textFieldForm = new Form("Confirm your address");
      TextField addressLine1 = new TextField("Address Line 1",
                                             "10 Main Street",
                                             20,
                                             TextField.ANY);
      TextField addressLine2 = new TextField("Address Line 2",
                                             "Townsville",
                                             20,
                                             TextField.ANY);
      TextField postcode = new TextField("Postcode", "7423",
                                         4, TextField.NUMERIC);
      textFieldForm.append(addressLine1);
      textFieldForm.append(addressLine2);
      textFieldForm.append(postcode);
      textFieldForm.addCommand(okCommand);
      textFieldForm.addCommand(backCommand);
      textFieldForm.addCommand(exitCommand);
      textFieldForm.setCommandListener(this);
      display.setCurrent(textFieldForm);
    }
    else if (c == okCommand) {
      Form textFieldForm = (Form)d;
      TextField addressLine1 =
        (TextField)(textFieldForm.get(0));
      TextField addressLine2 =
        (TextField)(textFieldForm.get(1));
      TextField postcode = (TextField)(textFieldForm.get(2));
      // display the result
      Alert alert = new Alert("Address Entered");
      alert.setString("The address is:\n" +
                      addressLine1.getString() + "\n" +
                      addressLine2.getString() + "\n" +
                      postcode.getString());
      alert.setTimeout(5000);
      alert.setType(AlertType.INFO);
      display.setCurrent(alert, mainForm);
    }
    else if (c == backCommand) {
      display.setCurrent(mainForm);
    }
    else {
      super.commandAction(c, d);
    }
  }
}
