package com.javaonpdas.networking;

import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;

public class HttpNetworking extends Frame
  implements ActionListener {

  private TextArea textArea = null;
  private DataInputStream dis = null;

  public HttpNetworking(String title) {
    super(title);
    // handle frame closing events
    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        System.exit(0);
      }
    } );
    setLayout(new FlowLayout(FlowLayout.LEFT, 10, 10));
    Button button = new Button("Open");
    add(button);
    button.addActionListener(this);
    textArea = new TextArea(12,28);
    add(textArea);
  }

  public void actionPerformed(ActionEvent evt) {
    String cmd = evt.getActionCommand();
    if (cmd.startsWith("Open")) {
      try {
        URL url = new URL("http://users.bigpond.com/ripple/JavaOnPDAs/HttpNetworking.html");
        HttpURLConnection c =
          (HttpURLConnection)url.openConnection();
        dis = new DataInputStream(c.getInputStream());
        byte[] buffer = new byte[c.getContentLength()];
        dis.readFully(buffer);
            String result = new String(buffer);
            textArea.setText(result);
      }
      catch (Exception e) {
        textArea.setText(e.getMessage());
      }
      finally {
        try {
          if (dis != null) dis.close();
        } catch (IOException e) {}
      }
    }
  }

  public static void main(String[] args) {
    Frame f = new HttpNetworking("HttpNetworking");
    f.setSize(f.getToolkit().getScreenSize());
    f.show();
  }
}
