package com.javaonpdas.persistence;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import java.util.zip.*;

public class SerializedObjects extends Frame
  implements TextListener, ItemListener {

  private File file = null;
  private Choice startsWith = null;
  private TextField animalName = null;
  private Hashtable animals = null;
  private static String[] letters = {"a", "b", "c", "d", "e",
                                     "f", "g", "h", "i", "j",
                                     "k", "l", "m", "n", "o",
                                     "p", "q", "r", "s", "t",
                                     "u", "v", "w", "x", "y",
                                     "z"};
  private static String dataFileName =
    "\\My Documents\\JavaOnPDAs\\animals.object";
  private ObjectInputStream in = null;
  private ObjectOutputStream out = null;

  public SerializedObjects(String title) {
    super(title);
    // handle frame closing events
    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        System.exit(0);
      }
    } );
    setLayout(new FlowLayout(FlowLayout.LEFT, 5, 5));
    // add the UI components
    add(new Label("Animal starting with"));
    startsWith = new Choice();
    for (int i=0; i<letters.length; i++) {
      startsWith.add(letters[i]);
    }
    startsWith.addItemListener(this);
    add(startsWith);
    animalName = new TextField(25);
    animalName.addTextListener(this);
    add(animalName);
    // fill the hashtable
    try {
      in = new ObjectInputStream(new GZIPInputStream(
        new FileInputStream(dataFileName)));
      animals = (Hashtable)in.readObject();
      in.close();
    }
    catch (Exception e) {
      animals = new Hashtable();
      animals.put("a", "ape");
      animals.put("b", "bear");
      animals.put("c", "cheetah");
      animals.put("d", "deer");
      animals.put("e", "elephant");
      animals.put("f", "fox");
      animals.put("g", "gorilla");
      animals.put("h", "hippopotamus");
      animals.put("i", "iguana");
      animals.put("j", "jazelle");
      animals.put("k", "koala");
      animals.put("l", "lion");
      animals.put("m", "monkey");
      animals.put("n", "<<no animal found>>");
      animals.put("o", "<<no animal found>>");
      animals.put("p", "parrot");
      animals.put("q", "<<no animal found>>");
      animals.put("r", "rat");
      animals.put("s", "snake");
      animals.put("t", "tortoise");
      animals.put("u", "<<no animal found>>");
      animals.put("v", "<<no animal found>>");
      animals.put("w", "<<no animal found>>");
      animals.put("x", "<<no animal found>>");
      animals.put("y", "<<no animal found>>");
      animals.put("z", "zebra");
    }
    finally {
      try { if (in != null) in.close(); }
      catch (IOException e) {}
    }
  }

  public void textValueChanged(TextEvent evt) {
    String selectedItem = startsWith.getSelectedItem();
    if (animals.containsKey(selectedItem)) {
      String currentValue = (String)animals.get(selectedItem);
      String newValue = animalName.getText();
      if (!currentValue.equals(newValue)) {
        // update the current key with the selected value
        animals.put(selectedItem, newValue);
        // save the hashtable
        try {
          out = new ObjectOutputStream(new GZIPOutputStream(
            new FileOutputStream(dataFileName)));
          out.writeObject(animals);
          out.flush();
          out.close();
        }
        catch (Exception e) {
        }
        finally {
          try { if (out != null) out.close(); }
          catch (IOException e) {}
        }
      }
    }
  }

  public void itemStateChanged(ItemEvent evt) {
    String value = (String)animals.get((String)evt.getItem());
    animalName.setText(value);
  }

  public static void main(String[] args) {
    Frame f = new SerializedObjects("SerializedObjects");
    f.setSize(f.getToolkit().getScreenSize());
    f.show();
  }
}
